import { createAppContainer } from 'react-navigation';
import { createStackNavigator} from 'react-navigation-stack';

import Welcome from './components/Welcome';
import Login from './components/Login';
import Register from './components/Register';
import Weather from './components/Weather';
import Profile from './components/Profile';
import Users from './components/Users';
import Map from './components/Map';
import Delay from './components/Delay';
import Driver from './components/Driver';
import AllUsers from './components/AllUsers';
import Stations from './components/Stations';
import DelayP from './components/DelayP';
import Details from './components/Details';
import UserStations from './components/UserStations';
import ForgotPassword from './components/ForgotPassword';
import { YellowBox } from 'react-native';
import _ from 'lodash';

console.disableYellowBox = true
YellowBox.ignoreWarnings(['Warning:']);
const _console = _.clone(console);
console.warn = message => {
  if (message.indexOf('Setting a timer') <= -1) {
    _console.warn(message);
  }
};
 
const App = createStackNavigator({
    Welcome: { screen: Welcome },
    Login: { screen: Login },
    Register: { screen: Register },
    ForgotPassword: { screen: ForgotPassword },
    Map: { screen: Map },
    Weather: { screen: Weather },
    Profile: { screen: Profile },
    AllUsers: { screen: AllUsers },
    Users: { screen: Users },
    Delay: { screen: Delay },
    DelayP: { screen: DelayP },
    Stations: { screen: Stations },
    Driver: { screen: Driver },
    Details: { screen: Details },
    UserStations: { screen: UserStations },
  },
  {
    initialRouteName: 'Welcome',
  }
);
export default createAppContainer(App);