import React, { Component } from "react";
import {
  Alert,
  Button,
  Picker,
  ActivityIndicator,
  TextInput,
  View,
  StyleSheet,
  TouchableOpacity,
  Text,
  Image,
  AsyncStorage,
  Dimensions,
  ScrollView,
} from "react-native";
import "react-native-gesture-handler";
import AwesomeAlert from "react-native-awesome-alerts";
import MapView from "react-native-maps";
import Constants from "expo-constants";
import * as Location from "expo-location";
import axios from "axios";
import LocalIP from "./localIP";

export default class Delay extends React.Component {
  constructor(props) {
    super(props);

    ssage: "",
      shothis.state = {
      mewAlert: false,
      loader: false,
      title: "",
      focusedLocation: {
        latitude: 6.886581,
        longitude: 79.918768,
        latitudeDelta: 0.0122,
        longitudeDelta:
          (Dimensions.get("window").width / Dimensions.get("window").height) *
          0.0122,
      },
      locationChosen: false,
      latitude: 6.886581,
      longitude: 79.918768,
      speed: 0.0,
      delay: 0,
      weather: "",
      temp: 0,
      hum: 0,
      wind:0
    };

    this.loadData();

    this.interval = setInterval(() => {
      this.getLocationHandler();
    }, 5000);

    this.interval = setInterval(() => {
      this.prediction();
    }, 6000);

  }

  loadData = async () => {
    const isLoggedIn = await AsyncStorage.getItem("isLoggedIn");
    const userType = await AsyncStorage.getItem("userType");
    if (isLoggedIn == "true" && userType == "Users") {
      this.props.navigation.navigate("Users");
    } else if (isLoggedIn == "true" && userType == "Driver") {
      this.props.navigation.navigate("Driver");
    }
  };

  static navigationOptions = ({ navigation }) => {
    return {
      headerTitle: "Delay & Weather",
      headerStyle: { backgroundColor: "#9dffab" },
      headerTintColor: "#000000",
    };
  };

  componentDidMount() {
    if (Platform.OS === "android" && !Constants.isDevice) {
      setErrorMsg(
        "Oops, this will not work on Sketch in an Android emulator. Try it on your device!"
      );
    } else {
      (async () => {
        let { status } = await Location.requestPermissionsAsync();
        if (status !== "granted") {
          setErrorMsg("Permission to access location was denied");
        }

        var location = await Location.installWebGeolocationPolyfill();
      })();
    }
  }

  logout = async () => {
    AsyncStorage.clear();
    this.props.navigation.navigate("Login");
  };

  loadData = async () => {
    const isLoggedIn = await AsyncStorage.getItem("isLoggedIn");
    if (isLoggedIn !== "true") {
    }
  };

  showAlert = () => {
    this.setState({
      showAlert: true,
    });
  };

  hideAlert = () => {
    this.setState({
      showAlert: false,
      message: "",
      title: "",
    });
  };

  getLocationHandler = () => {
    navigator.geolocation.getCurrentPosition(
      (pos) => {
        this.setState((prevState) => {
          return {
            focusedLocation: {
              ...prevState.focusedLocation,
              latitude: pos.coords.latitude,
              longitude: pos.coords.longitude,
            },
            latitude: pos.coords.latitude,
            longitude: pos.coords.longitude,
            speed: pos.coords.speed.toFixed(0),
          };
        });
      },
      (err) => {
        console.log(err);
        alert("Fetching the Position failed, please pick one manually!");
      }
    );
  };

  prediction = async () => {
     const url = 'https://api.openweathermap.org/data/2.5/weather?lat='+this.state.latitude+'&lon='+this.state.longitude+'&appid=5ba8ca2e49206416aa5e3af52be98256'
     await axios.get(url,{
         headers: {'Content-Type': 'application/json'}
     })
     .then(async(res) => {
       console.log(res['data']['wind']['speed'])
        var hum =(res['data']['main']['humidity']).toFixed(0)
        var temp = (res['data']['main']['temp']*1 - 273.15).toFixed(0)
        var wind = (res['data']['wind']['speed']).toFixed(2)
        this.setState({temp:temp,hum:hum,wind:wind})
     })
     var hours = new Date().getHours();
     var min = new Date().getMinutes();

     const urls="http://"+LocalIP+":3500/prediction/weather"
     const data = JSON.stringify({ time: hours+"."+min , lat: this.state.latitude , lang: this.state.longitude , temp: this.state.temp , hum: this.state.hum });
     await axios.post(urls,data,{
         headers: {'Content-Type': 'application/json'}
     }).then( res =>{
        this.setState({weather:res.data['data']})
     })

     var dis=this.getDistanceFromLatLonInKm(this.state.latitude,this.state.longitude,7.2950807,80.6317596)
     dis=(dis).toFixed(2)

     console.log(dis)
     var s=0,p=0,r=0,m=0,d=0
     if(this.state.weather=="Sunny"){
       console.log("s")
        s=1
        p=0
        r=0
        m=0
        d=0
     }else if(this.state.weather=="partialy cloudy"){
      s=0
      p=1
      r=0
      m=0
      d=0
     }else if(this.state.weather=="Rainy"){
      s=0
      p=0
      r=1
      m=0
      d=0
     }else if(this.state.weather=="Mostly cloudy"){
      s=0
      p=0
      r=0
      m=1
      d=0
    }else if(this.state.weather=="Drizzle"){
      s=0
      p=0
      r=0
      m=0
      d=1
    }

     const urls1="http://"+LocalIP+":3500/prediction/delay"
     const data1 = JSON.stringify({ wind: this.state.wind , avg_speed: this.state.speed , distance: dis , drizzle: d,m_cloudy: m,rainy: r,sunny: s,p_cloudy: p});
     await axios.post(urls1,data1,{
         headers: {'Content-Type': 'application/json'}
     }).then( res =>{
        this.setState({delay:res.data['data']})
     })

     const urls2="http://"+LocalIP+":3500/prediction/save"
     const data2 = JSON.stringify({ wind: this.state.wind , avg_speed: this.state.speed , distance: dis , drizzle: d,m_cloudy: m,rainy: r,sunny: s,p_cloudy: p,delay: (this.state.delay).toFixed(2) });
     await axios.put(urls2,data2,{
         headers: {'Content-Type': 'application/json'}
     }).then( res =>{
        console.log(res)
     })

  }

  getDistanceFromLatLonInKm(lat1,lon1,lat2,lon2) {
    var R = 6371; // Radius of the earth in km
    var dLat = this.deg2rad(lat2-lat1);  // deg2rad below
    var dLon = this.deg2rad(lon2-lon1); 
    var a = 
      Math.sin(dLat/2) * Math.sin(dLat/2) +
      Math.cos(this.deg2rad(lat1)) * Math.cos(this.deg2rad(lat2)) * 
      Math.sin(dLon/2) * Math.sin(dLon/2)
    var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a)); 
    var d = R * c; // Distance in km
    return d;
  }
  
  deg2rad(deg) {
    return deg * (Math.PI/180)
  }

  render() {
    const { showAlert } = this.state;
    const { diseaseArray } = this.state;
    let marker = null;

    if (this.state.locationChosen) {
      marker = <MapView.Marker coordinate={this.state.focusedLocation} />;
    }
    return (
      <ScrollView style={styles.scrollView}>
        <View style={styles.container}>
          <Image
            source={require("./../assets/logo.png")}
            style={{ width: 120, height: 120, marginBottom: 20, marginTop: 10 }}
          />

          <View
            style={{
              width: 80 + "%",
              flex: 1,
              flexDirection: "row",
              marginBottom: 5,
            }}
          >
            <View
              style={{
                width: 50 + "%",
                marginBottom: 5,
                alignItems: "center",
                justifyContent: "center",
              }}
            >
              <Text
                style={{ color: "#000000", fontWeight: "bold", fontSize: 20 }}
              >
                Average Speed
              </Text>
              <Text
                style={{ color: "#000000", fontWeight: "bold", fontSize: 15 }}
              >
                {this.state.speed} Km/h
              </Text>
            </View>
            <View
              style={{
                width: 50 + "%",
                marginBottom: 5,
                alignItems: "center",
                justifyContent: "center",
              }}
            >
              <Text
                style={{ color: "#000000", fontWeight: "bold", fontSize: 20 }}
              >
                Fort to Kandy
              </Text>
              <Text
                style={{ color: "#000000", fontWeight: "bold", fontSize: 15 }}
              >
                Weather : {this.state.weather}
              </Text>
            </View>
          </View>

          <View
            style={{
              width: 80 + "%",
              flex: 1,
              flexDirection: "row",
              borderBottomColor: "#bdb9ae",
              borderBottomWidth: 2,
              marginBottom: 5,
            }}
          >
            <View
              style={{
                width: 100 + "%",
                marginBottom: 5,
                alignItems: "center",
                justifyContent: "center",
              }}
            >
              <Text
                style={{ color: "#000000", fontWeight: "bold", fontSize: 15 }}
              >
                {this.state.delay} Minutes Delayed
              </Text>
            </View>
          </View>

          <MapView
            initialRegion={this.state.focusedLocation}
            region={
              !this.state.locationChosen ? this.state.focusedLocation : null
            }
            style={{
              width: 80 + "%",
              height: Dimensions.get("window").height * 0.6,
              borderWidth: 1,
              marginBottom: 10,
              marginLeft: 4,
              borderColor: "#c4c4c4",
            }}
            zoomEnabled={true}
            pitchEnabled={true}
            showsUserLocation={true}
            followsUserLocation={true}
            showsCompass={true}
            showsBuildings={true}
            showsIndoors={true}
            ref={(ref) => (this.map = ref)}
          >
            {marker}
          </MapView>

          <AwesomeAlert
            show={showAlert}
            title={this.state.title}
            message={this.state.message}
            closeOnTouchOutside={true}
            closeOnHardwareBackPress={false}
            showCancelButton={true}
            cancelText="Close"
            cancelButtonColor="#AEDEF4"
            onCancelPressed={() => {
              this.hideAlert();
            }}
          />
        </View>
      </ScrollView>
    );
  }
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    alignItems: "center",
    justifyContent: "center",
    backgroundColor: "#ffffff",
  },
  map: {
    width: "100%",
    height: 600,
  },
  button: {
    margin: 8,
  },
  input: {
    borderBottomWidth: 1,
    width: 80 + "%",
    height: 45,
    marginBottom: 20,
    flexDirection: "row",
    alignItems: "center",
    marginLeft: 4,
    borderBottomColor: "#c4c4c4",
    color: "#000000",
  },
  TextInputStyleClass: {
    borderBottomWidth: 1,
    width: 80 + "%",
    height: 100,
    marginBottom: 20,
    flexDirection: "row",
    alignItems: "center",
    marginLeft: 4,
    borderBottomColor: "#c4c4c4",
    color: "#000000",
  },
  buttonContainer: {
    flexDirection: "row",
    justifyContent: "center",
    alignItems: "center",
    marginBottom: 10,
    width: 80 + "%",
    height: 40,
    borderRadius: 60,
  },
  loginButton: {
    backgroundColor: "#348ceb",
  },
  registerButton: {
    backgroundColor: "#7b00ff",
  },
});
