import React, { Component } from 'react';
import { Alert, Button, Picker , ActivityIndicator , TextInput , View, StyleSheet, TouchableOpacity, Text, Image , AsyncStorage , Dimensions  , ScrollView } from 'react-native';
import 'react-native-gesture-handler';
import AwesomeAlert from 'react-native-awesome-alerts';
import Constants from 'expo-constants';
import * as Location from "expo-location";
import axios from 'axios';
import LocalIP from './localIP';

export default class Details extends React.Component {
  constructor(props) {
    super(props);
    
    this.state = {
      message:'',
      showAlert: false,
      loader: false,
      title:'',
      details:[]
    };

    this.interval = setInterval(() => {
      this.componentDidMount();
    }, 1000);

  }

  loadData = async() =>{
    const isLoggedIn = await AsyncStorage.getItem('isLoggedIn')
    const userType = await AsyncStorage.getItem('userType')
    if(isLoggedIn=='true'&&userType=="Users"){
      this.props.navigation.navigate('Users')
    }else if(isLoggedIn=='true'&&userType=="Driver"){
      this.props.navigation.navigate('Driver')
    }
  }

  static navigationOptions = ({ navigation}) => {
    return {
      headerTitle: 'All Details',
      headerStyle: { backgroundColor: '#9dffab' },
      headerTintColor: '#000000',
    }
  };

  componentDidMount= async()=> {
    const url="http://"+LocalIP+":3500/prediction/details"
    await axios.get(url,{
         headers: {'Content-Type': 'application/json'}
     }).then( res =>{

      this.setState({details:res.data})

    })
  }

  logout = async() => {
    AsyncStorage.clear();
    this.props.navigation.navigate('Login')
  }

  loadData = async() =>{
    const isLoggedIn = await AsyncStorage.getItem('isLoggedIn')
    if(isLoggedIn!=='true'){

    }
  }
  
  showAlert = () => {
    this.setState({
      showAlert: true
    });
  };
 
  hideAlert = () => {
    this.setState({
      showAlert: false,
      message: '',
      title: ''
    });
  };

  render() {
    const {showAlert} = this.state;
    const {details} = this.state;

    return (
      <ScrollView style={styles.scrollView}>
        <View style={styles.container}>
          <Image source={require('./../assets/logo.png')}
            style={{width: 120, height: 120 ,marginBottom:20 , marginTop:10}} />
          {
            details.map((record) =>
            <View style={{width: 80 + '%',flex: 1, flexDirection: 'row',marginBottom:5}}>
              <View style={{width: 50 + '%',marginBottom:5,alignItems: 'center',justifyContent: 'center'}}>
                <Text style={{color: '#000000', fontWeight: 'bold' ,fontSize: 20}}>{record.name}</Text>
              </View>
              <View style={{width: 50 + '%',marginBottom:5,alignItems: 'center',justifyContent: 'center'}}>
                <Text style={{color: '#000000', fontWeight: 'bold' ,fontSize: 20}}>{record.value}</Text>
              </View>
            </View>
          )}

          <AwesomeAlert
              show={showAlert}
              title={this.state.title}
              message={this.state.message}
              closeOnTouchOutside={true}
              closeOnHardwareBackPress={false}
              showCancelButton={true}
              cancelText="Close"
              cancelButtonColor="#AEDEF4"
              onCancelPressed={() => {
                this.hideAlert();
              }}
            />

        </View>
      </ScrollView>
    );
  }
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    alignItems: 'center',
    justifyContent: 'center',
    backgroundColor: '#ffffff',
  },
  map: {
    width: "100%",
    height: 600
  },
  button: {
    margin: 8
  },
  input: {
    borderBottomWidth: 1,
    width: 80 + '%',
    height:45,
    marginBottom:20,
    flexDirection: 'row',
    alignItems:'center',
    marginLeft: 4, 
    borderBottomColor: '#c4c4c4',
    color: '#000000'
  },
  TextInputStyleClass:{
    borderBottomWidth: 1,
    width: 80 + '%',
    height:100,
    marginBottom:20,
    flexDirection: 'row',
    alignItems:'center',
    marginLeft: 4, 
    borderBottomColor: '#c4c4c4',
    color: '#000000'
  },
  buttonContainer: {
    flexDirection: 'row',
    justifyContent: 'center',
    alignItems: 'center',
    marginBottom:10,
    width: 80 + '%',
    height: 40,
    borderRadius: 60
  },
  loginButton: {
    backgroundColor: "#348ceb",
  },
  registerButton: {
    backgroundColor: "#7b00ff",
  }
});