import React from "react";
import { TextInput, View, ActivityIndicator , StyleSheet, TouchableOpacity, Text, Image, ScrollView} from "react-native";
import RadioForm from "react-native-simple-radio-button";
import AwesomeAlert from "react-native-awesome-alerts";
import axios from 'axios';
import LocalIP from './localIP';
import utf8 from 'utf8'
import base64 from 'base-64'

const initialState = {
  fname: "",
  lname: "",
  email: "",
  password: "",
  cpassword: "",
  type: "",
  message: "",
  showAlert: false,
  loader: false,
  title: "",
};

var radio_props = [
  { label: "Passenger  ", value: "1" },
  { label: "Driver", value: "2" },
];

export default class Register extends React.Component {

  state = initialState;

  static navigationOptions = ({ navigation}) => {
    return {
      headerTitle: 'Register',
      headerStyle: { backgroundColor: '#9dffab' },
      headerTintColor: '#000000',
      headerLeft: () => {
        return null;
      }
    }
  };

  constructor(props) {
    super(props);
  }

  showAlert = () => {
    this.setState({
      showAlert: true,
    });
  };

  hideAlert = () => {
    this.setState({
      showAlert: false,
      message: "",
      title: "",
    });
  };

  validation =()=>{
    if (this.state.email != "") {
      if (this.state.fname != "") {
        if (this.state.lname != "") {
          if (this.state.password != "") {
            if (this.state.cpassword != "") {
              if (this.state.password == this.state.cpassword) {
                var reg = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/;
                if (reg.test(this.state.email) === true){
                  return true;
                } else {
                  this.setState({
                    title: "Error!",
                    message: "Invalid Email!",
                  });
                  this.showAlert();
                }

              } else {
                this.setState({
                  title: "Error!",
                  message: "Password & Confirm Password Not Equals!",
                });
                this.showAlert();
              }
            } else {
              this.setState({
                title: "Required!",
                message: "Enter an Confirm Password!",
              });
              this.showAlert();
            }
          } else {
            this.setState({ title: "Required!", message: "Enter an Password!" });
            this.showAlert();
          }
        } else {
          this.setState({ title: "Required!", message: "Enter an Last Name!" });
          this.showAlert();
        }
      } else {
        this.setState({ title: "Required!", message: "Enter an First Name!" });
        this.showAlert();
      }
    } else {
      this.setState({ title: "Required!", message: "Enter an Email!" });
      this.showAlert();
    }
    return false;
  }

  onRegister = async(e) => {
    if(await this.validation()){
      this.setState({loader:true})
      const url = 'http://'+LocalIP+':3500/user/';
      const data = JSON.stringify({ fname: this.state.fname , lname: this.state.lname , email: this.state.email , password: base64.encode(utf8.encode(this.state.password)) , userType: this.state.type });
      await axios.post(url,data,{
          headers: {'Content-Type': 'application/json'}
      })
      .then(res => {
          console.log(res.data["err"]);
          this.setState(initialState)
          if(res.data["err"]=="email"){
            this.setState({ title: "Error!", message: "This Email Already Exists!" ,email:"" });
            this.showAlert();
          }else if(res.data["err"]=="connection"){
            this.setState({ title: "Error!", message: "Connection Error!" });
            this.showAlert();
          }else if(res.data["err"]=="data"){
            this.setState({ title: "Error!", message: "Invalid Data!" });
            this.showAlert();
          }else{
            this.setState({title:"Success!",message:"Register Successful!"})
            this.showAlert()
          }
      })
    }
  };

  render() {
    const { showAlert } = this.state;
    return (
      <ScrollView>
        <View style={styles.container}>
          <View style={styles.center}>
            <Image
              source={require("./../assets/logo.png")}
              style={{ width: 350, height: 350 }}
            />
          </View>

          <Text  style={styles.firstLabelText}>First Name:</Text>
          <View style={styles.center}>
            <TextInput
              value={this.state.fname}
              onChangeText={(fname) => this.setState({ fname })}
              placeholder={"First Name"}
              style={styles.input}
            />
          </View>

          <Text  style={styles.firstLabelText}>Last Name:</Text>
          <View style={styles.center}>
            <TextInput
              value={this.state.lname}
              onChangeText={(lname) => this.setState({ lname })}
              placeholder={"Last Name"}
              style={styles.input}
            />
          </View>

          <Text  style={styles.firstLabelText}>Email:</Text>
          <View style={styles.center}>
          <TextInput
            value={this.state.email}
            onChangeText={(email) => this.setState({ email })}
            placeholder={"Email"}
            style={styles.input}
          />
          </View>

          <Text  style={styles.firstLabelText}>Password:</Text>
          <View style={styles.center}>
          <TextInput
            value={this.state.password}
            onChangeText={(password) => this.setState({ password })}
            placeholder={"Password"}
            secureTextEntry={true}
            style={styles.input}
          />
          </View>

          <Text  style={styles.firstLabelText}>Confirm Password:</Text>
          <View style={styles.center}>
          <TextInput
            value={this.state.cpassword}
            onChangeText={(cpassword) => this.setState({ cpassword })}
            placeholder={"Confirm Password"}
            secureTextEntry={true}
            style={styles.input}
          />
          </View>

          <Text  style={styles.firstLabelText}>User Type:{"\n"}</Text>
          <View style={styles.center}>
            <RadioForm
              radio_props={radio_props}
              formHorizontal={true}
              labelHorizontal={true}
              buttonColor={"#000000"}
              selectedButtonColor={"#9dffab"}
              animation={true}
              buttonSize={15}
              labelStyle={{ fontSize: 15 }}
              style={{ marginBottom: 30 }}
              initial={ this.state.type }
              onPress={(value) => {
                this.setState({ type: value });
              }}
            />
          </View>

          <View style={styles.center}>
          <TouchableOpacity style={[styles.buttonContainer, styles.loginButton]} onPress={this.onRegister} >
              {!this.state.loader ? (
                <Text style={{ color: "#000000", fontWeight: "bold" }}>Register</Text>
              ) : null}
              {this.state.loader ? (
                  <ActivityIndicator size="large" color={"#ffffff"} />
              ) : null}
          </TouchableOpacity>

          <TouchableOpacity onPress={() => this.props.navigation.navigate("Login")} style={[styles.buttonContainer, styles.registerButton]} >
            <Text style={{ color: "#ffffff", fontWeight: "bold" }}>Login</Text>
          </TouchableOpacity>
          </View>

          <AwesomeAlert
            show={showAlert}
            title={this.state.title}
            message={this.state.message}
            closeOnTouchOutside={true}
            closeOnHardwareBackPress={false}
            showCancelButton={true}
            cancelText="Close"
            cancelButtonColor="#AEDEF4"
            onCancelPressed={() => {
              this.hideAlert();
            }}
          />
        </View>
      </ScrollView>
    );
  }
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    backgroundColor: '#ffffff',
  },
  center:{
    alignItems: 'center',
  },
  labelText:{
    fontWeight: 'bold' ,
    fontSize: 14 , 
    marginLeft: 10+'%',
    marginBottom: 10
  },
  firstLabelText:{
    fontWeight: 'bold' ,
    fontSize: 14 , 
    marginLeft: 10+'%',
    marginTop: 2+'%',
  },
  input: {
    borderBottomWidth: 1,
    width: 80 + '%',
    height:45,
    marginBottom:20,
    flexDirection: 'row',
    alignItems:'center',
    borderBottomColor: '#c4c4c4',
    color: '#000000'
  },
  TextInputStyleClass:{
    borderBottomWidth: 1,
    width: 80 + '%',
    height:100,
    marginBottom:20,
    flexDirection: 'row',
    alignItems:'center',
    borderBottomColor: '#c4c4c4',
    color: '#000000'
  },
  buttonContainer: {
    flexDirection: 'row',
    justifyContent: 'center',
    alignItems: 'center',
    marginBottom:10,
    width: 80 + '%',
    height: 40,
    borderRadius: 60
  },
  loginButton: {
    backgroundColor: "#9dffab",
  },
  registerButton: {
    backgroundColor: "#000000",
  }
});
